package uk.co.his.I78;

import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Id;
import javax.persistence.MapKey;
import javax.persistence.OneToMany;
import javax.persistence.Version;

@Entity
public class Container {

	public static Container getInstance(EntityManager em) {
		Container c = em.find(Container.class, "1");
		if (c == null) {
			c = new Container();
			em.persist(c);
		}
		return c;
	}

	@Id
	protected String id = "1";

	@SuppressWarnings("unused") //JPA
	@Version
	private int version;

	protected Container() {
	}

	
	@OneToMany(cascade = CascadeType.ALL, mappedBy = "container")
	@MapKey(name = "key")
	private java.util.Map<java.lang.String, Item> items = new java.util.HashMap<java.lang.String, Item>();

	private Item putNewItem(java.lang.String key, Item newObj, EntityManager em) {
		newObj.setUUID();
		em.getMetamodel().entity(Item.class);
		em.persist(newObj);
		items.put(key, newObj);
		newObj.setContainer(this);
		newObj.setKey(key);
		return newObj;
	}

	public Item addItem(String id, EntityManager em) {
		Item item = putNewItem(id, new Item(), em);
		return item;
	}

	@Basic 
	private java.lang.String testString;

	public java.lang.String getTestString() {
		return testString;
	}

	public void setTestString(java.lang.String testString) {
		this.testString = testString;
	}
	
	

}
